#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char ** argv){
 double alt,az,ha,delta,fi;
 if( argc<3 ){fprintf(stderr,"Usage: %s altitide_deg azimuth_deg\n",argv[0]);return 1;}
 fi=38.0+(15.0/60.0)+(2.93/3600.0);
 alt=atof(argv[1]);
 if( alt>90.0 || alt<-90.0 ){fprintf(stderr,"Problem with altitude: %lf\nUsage: %s altitide_deg azimuth_deg\n",alt,argv[0]);return 1;}
 az=atof(argv[2]);
 if( az<0.0 || az>360.0 ){fprintf(stderr,"Problem with azimuth: %lf\nUsage: %s altitide_deg azimuth_deg\n",az,argv[0]);return 1;} 
 az=az-180.0;
 alt=alt*M_PI/180.0;
 az=az*M_PI/180.0;
 fi=fi*M_PI/180.0;
 ha=atan2( sin(az) , cos(az)*sin(fi)+tan(alt)*cos(fi) );
 delta=asin( sin(fi)*sin(alt)-cos(fi)*cos(alt)*cos(az) );
 delta=delta*180.0/M_PI;
 ha=ha*180.0/M_PI;
 alt=alt*180.0/M_PI;
 az=az*180.0/M_PI;
 fi=fi*180.0/M_PI;
 ha=ha/15.0; // deg->hrs
// fprintf(stderr,"fi=%lf alt=%lf az=%lf HA=%lf delta=%lf\n",fi,alt,az,ha,delta);

 // Check if there is a problem for GB
 //if( alt<15.0 )return 1;
 if( alt<11.0 )return 1;
 if( ha<-6.5 || ha>6.5 )return 1;
 if( delta<-37.0 || delta>77.0 )return 1;

 return 0;
}
